/*------------------------------------------------------------
	DirectX8 Graphics

	TvvO XvCgiCŁj

	2001 Copyright(C) DOIchan!
		doichan@bigfoot.com
		http://www.bigfoot.com/~doichan/
--------------------------------------------------------------*/

#define STRICT
#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>

#define RELEASE(x) 	if(x){x->Release();x=NULL;}

/*-------------------------------------------
	AvP[Vf[^
--------------------------------------------*/
HINSTANCE hInstApp;
HWND hwndApp;
char szAppName[] = "DirectX8 Graphics: Sprite";

LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam);

int appActive = FALSE;

/*--------------------------------------------
	DirectXIuWFNg
--------------------------------------------*/
LPDIRECT3D8 pD3D = NULL;
LPDIRECT3DDEVICE8 pD3DDevice = NULL;

LPDIRECT3DTEXTURE8 pTexture[2] = {NULL,NULL};

D3DPRESENT_PARAMETERS d3dppApp;


LPD3DXSPRITE pSprite = NULL;

/*-------------------------------------------
	foCX/[h̏
--------------------------------------------*/
int InitDevices(void)
{
	//Direct3DIuWFNg̎擾
	pD3D = Direct3DCreate8(D3D_SDK_VERSION);
	if(pD3D == NULL)
		return FALSE;

	D3DDISPLAYMODE dmode;

	//݂̃fBXvC[h𓾂
	if(FAILED(pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&dmode)))	//DEFAULTwŃvC}A_v^I
		return FALSE;
	//obNT[tF[X̃tH[}bgRs[Ďgp
	ZeroMemory(&d3dppApp,sizeof(d3dppApp));
	d3dppApp.Windowed = TRUE;							//EBhE[h
	d3dppApp.SwapEffect = D3DSWAPEFFECT_DISCARD;		//Ńtbv
	d3dppApp.BackBufferFormat = dmode.Format;
	d3dppApp.BackBufferCount = 1;

	//foCX̍쐬
	if(FAILED(pD3D->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwndApp,D3DCREATE_HARDWARE_VERTEXPROCESSING,&d3dppApp,&pD3DDevice))){
		if(FAILED(pD3D->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwndApp,D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dppApp,&pD3DDevice)))
			return FALSE;
	}

	//eNX`̓ǂݍ
	D3DXCreateTextureFromFile(pD3DDevice,"chr.dds",&pTexture[0]);
	D3DXCreateTextureFromFile(pD3DDevice,"back.bmp",&pTexture[1]);

	//XvCg쐬
	D3DXCreateSprite(pD3DDevice,&pSprite);

	return TRUE;
}



/*-------------------------------------------
	Ȉ
--------------------------------------------*/
int EndApp(void)
{
	RELEASE(pTexture[0]);
	RELEASE(pTexture[1]);
	RELEASE(pSprite);

	RELEASE(pD3DDevice);
	RELEASE(pD3D);

	return TRUE;
}

D3DXVECTOR2 chrPos[2];
D3DXVECTOR2 chrDir[2];
int rotBack = 0;


/*-------------------------------------------
	`揈
---------------------------------------------*/
int Draw(void)
{
	if(!pD3D)
		return FALSE;
	if(!pD3DDevice)
		return FALSE;

	//œhԂď
	pD3DDevice->Clear(0,NULL,D3DCLEAR_TARGET,D3DCOLOR_XRGB(0,0,0),1.0,0);
	pD3DDevice->BeginScene();

	//XvCg`Jn
	pSprite->Begin();

	RECT srcRect;
	int i;
	D3DXVECTOR2 v(128,128);

	SetRect(&srcRect,0,0,256,256);
	pSprite->Draw(pTexture[1],&srcRect,NULL,&v,D3DXToRadian(rotBack % 360),&chrPos[1],0xffffffff);
	pSprite->Draw(pTexture[0],&srcRect,NULL,NULL,0,&chrPos[0],0xffffffff);

	pSprite->End();

	pD3DDevice->EndScene();
	pD3DDevice->Present(NULL,NULL,NULL,NULL);

	for(i=0;i<2;i++){
		chrPos[i].x += chrDir[i].x;
		chrPos[i].y += chrDir[i].y;
		if(chrPos[i].x < 0){
			chrPos[i].x = 0;
			chrDir[i].x = 1;
		}
		else if(chrPos[i].x + 256 > d3dppApp.BackBufferWidth){
			chrPos[i].x = (float)(d3dppApp.BackBufferWidth - 256 - 1);
			chrDir[i].x = -1;
		}
		if(chrPos[i].y < 0){
			chrPos[i].y = 0;
			chrDir[i].y = 1;
		}
		else if(chrPos[i].y + 256 > d3dppApp.BackBufferHeight){
			chrPos[i].y = (float)(d3dppApp.BackBufferHeight - 256 - 1);
			chrDir[i].y = -1;
		}
	}

	rotBack += 1;

	return TRUE;
}


/*-------------------------------------------
	EBhE
--------------------------------------------*/
LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam)
{
	static timerID;
	static int sizeMoving = FALSE;

	switch(msg){
		case WM_CREATE:
			timerID = SetTimer(hWnd,1,0,NULL);
			break;
		case WM_ACTIVATE:
			appActive = !((BOOL)HIWORD(wParam));
			break;
		case WM_PAINT:
			Draw();
			ValidateRect(hWnd,NULL);
			break;
		case WM_SIZE:
			if(wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED){
				d3dppApp.BackBufferWidth = LOWORD(lParam);
				d3dppApp.BackBufferHeight = HIWORD(lParam);
				if(pD3DDevice && !sizeMoving){
					pD3DDevice->Reset(&d3dppApp);
					RELEASE(pSprite);
					D3DXCreateSprite(pD3DDevice,&pSprite);

					InvalidateRect(hWnd,NULL,TRUE);
				}
			}
			break;
		case WM_ENTERSIZEMOVE:
			sizeMoving = TRUE;
			break;
		case WM_EXITSIZEMOVE:
			sizeMoving = FALSE;
			if(pD3DDevice){
				pD3DDevice->Reset(&d3dppApp);
				RELEASE(pSprite);
				D3DXCreateSprite(pD3DDevice,&pSprite);
				InvalidateRect(hWnd,NULL,TRUE);
			}
			break;
		case WM_TIMER:
			Draw();
			break;
		case WM_KEYDOWN:
			switch(wParam){
				case VK_ESCAPE:
				case VK_F12:
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				default:
					break;
			}
			break;
		case WM_DESTROY:
			KillTimer(hWnd,timerID);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd,msg,wParam,lParam);
	}
	return 0L;
}


/*--------------------------------------------
	ACh̏
--------------------------------------------*/
int AppIdle(void)
{

	return TRUE;
}

/*--------------------------------------------
	C
---------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	WNDCLASSEX wndclass;
	RECT rect;

	hInstApp=hInst;
	//EBhENX̓o^
	wndclass.cbSize 		= sizeof(WNDCLASSEX);
	wndclass.style			= CS_CLASSDC;
	wndclass.lpfnWndProc	= (WNDPROC)MainWndProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInst;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground	= NULL;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= "DX8 Main Window";
	wndclass.hIconSm		= NULL;

	if(!RegisterClassEx(&wndclass))
		return FALSE;

	//CEBhE쐬
	rect.left = 0;
	rect.top = 0;
	rect.right = 640;
	rect.bottom = 480;
	AdjustWindowRect(&rect,WS_OVERLAPPEDWINDOW,TRUE);
	hwndApp = CreateWindowEx(0,"DX8 Main Window",szAppName,
							WS_OVERLAPPEDWINDOW,
							CW_USEDEFAULT,CW_USEDEFAULT,rect.right - rect.left,rect.bottom - rect.left,
							(HWND)NULL,(HMENU)NULL,
							hInst,(LPSTR)NULL);
	if(!InitDevices()){
		EndApp();
		return FALSE;
	}

	chrPos[0].x = 0;	chrPos[0].y = 0;
	chrDir[0].x = 1;	chrDir[0].y = 1;
	chrPos[1].x = 300;	chrPos[1].y = 200;
	chrDir[1].x = -1;	chrDir[1].y = 1;

	ShowWindow(hwndApp,nCmdShow);
	UpdateWindow(hwndApp);

	//bZ[W[v
	while(TRUE){
		if(PeekMessage(&msg,0,0,0,PM_NOREMOVE)){
			if(!GetMessage(&msg,NULL,0,0))
				break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else if(appActive){
			AppIdle();
		}
		else{
			WaitMessage();
		}
	}

	EndApp();

	return msg.wParam;
}



